## bfs 1.1.1

=== Makefile ===
############################################################################
# bfs                                                                      #
# Copyright (C) 2015-2017 Tavian Barnes <tavianator@tavianator.com>        #
#                                                                          #
# Permission to use, copy, modify, and/or distribute this software for any #
# purpose with or without fee is hereby granted.                           #
#                                                                          #
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES #
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF         #
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR  #
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   #
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN    #
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF  #
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.           #
############################################################################

ifeq ($(wildcard .git),)
VERSION := 1.1.1
else
VERSION := $(shell git describe --always)
endif

CC ?= gcc
WFLAGS ?= -Wall -Wmissing-declarations
CFLAGS ?= -g $(WFLAGS)
LDFLAGS ?=
DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)
RM ?= rm -f
INSTALL ?= install

DESTDIR ?=
PREFIX ?= /usr

LOCAL_CPPFLAGS := \
    -D__EXTENSIONS__ \
    -D_ATFILE_SOURCE \
    -D_BSD_SOURCE \
    -D_DARWIN_C_SOURCE \
    -D_DEFAULT_SOURCE \
    -D_FILE_OFFSET_BITS=64 \
    -D_GNU_SOURCE \
    -DBFS_VERSION=\"$(VERSION)\"

LOCAL_CFLAGS := -std=c99

ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
ALL_CFLAGS = $(ALL_CPPFLAGS) $(LOCAL_CFLAGS) $(CFLAGS) $(DEPFLAGS)
ALL_LDFLAGS = $(ALL_CFLAGS) $(LDFLAGS)

all: bfs

bfs: bftw.o color.o dstring.o eval.o exec.o main.o mtab.o parse.o printf.o typo.o util.o
	$(CC) $(ALL_LDFLAGS) $^ -o $@

release: CFLAGS := -O3 -flto $(WFLAGS) -DNDEBUG -g
release: bfs

%.o: %.c
	$(CC) $(ALL_CFLAGS) -c $< -o $@

check: all
	./tests.sh

clean:
	$(RM) bfs *.o *.d

install:
	$(INSTALL) -D -m755 bfs $(DESTDIR)$(PREFIX)/bin/bfs

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs

.PHONY: all release check clean install uninstall

-include $(wildcard *.d)

=== debian/changelog ===
bfs (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Move autopkgtests to separate files.
  * Tidy debian/tests/control.
  * Refresh and renumber patches, sorting using Pq-Topic.

 -- Chris Lamb <lamby@debian.org>  Mon, 14 Aug 2017 08:41:02 -0700

bfs (1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 28 Jul 2017 08:42:16 +0100

bfs (1.0.2-6) unstable; urgency=medium

  * Install RELEASES.md, not README.md, as the upstream changelog. Thanks to
    Tavian Barnes for spotting this.

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Jul 2017 20:39:19 +0100

bfs (1.0.2-5) unstable; urgency=medium

  * Don't use the upstream "release" Makefile target as it overrides CFLAGS.
    Thanks to Tavian Barnes.
  * Install upstream's README.md as the upstream changelog.

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Jul 2017 20:02:06 +0100

bfs (1.0.2-4) unstable; urgency=medium

  * Set hardening=+all for bindnow, etc.

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Jul 2017 09:46:28 +0100

bfs (1.0.2-3) unstable; urgency=medium

  * Actually include the manpage in the package.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Jul 2017 22:40:09 +0100

bfs (1.0.2-2) unstable; urgency=medium

  * Use help2man to generate a manpage.

 -- Chris Lamb <lamby@debian.org>  Fri, 14 Jul 2017 14:50:29 +0100

bfs (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.0.
  * Add a basic smoke autopkgtest.
  * Update 0002-Drop-fstype-tests-as-they-rely-on-etc-mtab-being-ava.patch.

 -- Chris Lamb <lamby@debian.org>  Mon, 26 Jun 2017 09:31:01 +0100

bfs (1.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Correct debian/watch file. Thanks to Tavian Barnes.
  * Refresh patches:
    - 0003-Fix-FTBFS-on-hurd-i386.-Closes-861569.patch dropped upstream

 -- Chris Lamb <lamby@debian.org>  Tue, 23 May 2017 19:11:06 +0100

bfs (1.0-4) unstable; urgency=medium

  * Drop Drop-printf_times-tests-as-they-fail-under-eg.-Docke.patch as it now
    appears to work.

 -- Chris Lamb <lamby@debian.org>  Tue, 02 May 2017 08:59:55 +0100

bfs (1.0-3) unstable; urgency=medium

  * Fix FTBFS on hurd-i386. (Closes: #861569)

 -- Chris Lamb <lamby@debian.org>  Mon, 01 May 2017 08:34:42 +0100

bfs (1.0-2) unstable; urgency=medium

  * Drop fstype tests as they rely on /etc/mtab being available.
    (Closes: #861471)

 -- Chris Lamb <lamby@debian.org>  Sat, 29 Apr 2017 14:00:35 +0100

bfs (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #861227)

 -- Chris Lamb <lamby@debian.org>  Wed, 12 Apr 2017 21:38:14 +0100

=== debian/control ===
Source: bfs
Section: utils
Priority: extra
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 10),
 help2man,
Standards-Version: 4.0.0
Homepage: https://github.com/tavianator/bfs
Vcs-Git: https://github.com/lamby/pkg-bfs.git
Vcs-Browser: https://github.com/lamby/pkg-bfs

Package: bfs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: Breadth-first version of find(1)
 bfs is a variant of the UNIX `find` command that operates breadth-first rather
 than depth-first.
 .
 It tries to be easier to use than `find`, while remaining compatible with
 find(1). For example, bfs is less picky about where you put its arguments.
 bfs also adds some extra options that make some common tasks easier.
 .
 When bfs detects that its output is a terminal, it automatically colors its
 output with the same colors ls uses.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_clean:
	rm -f bfs.1

override_dh_auto_build:
	dh_auto_build
	help2man \
		--name="Breadth-first version of find(1)" \
		--no-info \
		./bfs > bfs.1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./tests.sh
endif

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.md

## bfs 1.2.1

=== Makefile ===
--- 
+++ 
@@ -15,18 +15,20 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.1.1
+VERSION := 1.2.1
 else
 VERSION := $(shell git describe --always)
 endif
 
 CC ?= gcc
+INSTALL ?= install
+MKDIR ?= mkdir -p
+RM ?= rm -f
+
 WFLAGS ?= -Wall -Wmissing-declarations
 CFLAGS ?= -g $(WFLAGS)
 LDFLAGS ?=
 DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)
-RM ?= rm -f
-INSTALL ?= install
 
 DESTDIR ?=
 PREFIX ?= /usr
@@ -49,7 +51,7 @@
 
 all: bfs
 
-bfs: bftw.o color.o dstring.o eval.o exec.o main.o mtab.o parse.o printf.o typo.o util.o
+bfs: bftw.o color.o dstring.o eval.o exec.o main.o mtab.o opt.o parse.o printf.o stat.o typo.o util.o
 	$(CC) $(ALL_LDFLAGS) $^ -o $@
 
 release: CFLAGS := -O3 -flto $(WFLAGS) -DNDEBUG -g
@@ -65,7 +67,10 @@
 	$(RM) bfs *.o *.d
 
 install:
-	$(INSTALL) -D -m755 bfs $(DESTDIR)$(PREFIX)/bin/bfs
+	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
+	$(INSTALL) -m755 bfs $(DESTDIR)$(PREFIX)/bin/bfs
+	$(MKDIR) $(DESTDIR)$(PREFIX)/share/man/man1
+	$(INSTALL) -m644 bfs.1 $(DESTDIR)$(PREFIX)/share/man/man1/bfs.1
 
 uninstall:
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs

=== debian/changelog ===
bfs (1.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 12 Feb 2018 10:12:50 +0000

bfs (1.2-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * debian/copyright: Use https for format URI.
  * Move to debhelper compat level 11.
  * Bump Standards-Version to 4.1.3.

 -- Chris Lamb <lamby@debian.org>  Mon, 22 Jan 2018 13:27:26 +1100

bfs (1.1.4-2) unstable; urgency=medium

  * Use upstream's manpage.
  * wrap-and-sort -sa.

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Nov 2017 15:43:00 +0000

bfs (1.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Replace "Priority: extra" with "Priority: optional".

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Nov 2017 10:13:27 +0000

bfs (1.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.1.

 -- Chris Lamb <lamby@debian.org>  Tue, 10 Oct 2017 22:00:43 +0100

bfs (1.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop DPKG_EXPORT_BUILDFLAGS and /usr/share/dpkg/buildflags.mk include;
    they are not necessary with debhelper 10.

 -- Chris Lamb <lamby@debian.org>  Tue, 12 Sep 2017 10:53:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: bfs
 Section: utils
-Priority: extra
+Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 10),
- help2man,
-Standards-Version: 4.0.0
+ debhelper (>= 11),
+Standards-Version: 4.1.3
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://github.com/lamby/pkg-bfs.git
 Vcs-Browser: https://github.com/lamby/pkg-bfs
@@ -14,7 +13,7 @@
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: Breadth-first version of find(1)
  bfs is a variant of the UNIX `find` command that operates breadth-first rather
  than depth-first.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	./tests.sh
endif

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.md

=== debian/watch ===
version=3
https://github.com/tavianator/bfs/releases .*/(.*)\.tar\.gz

## bfs 1.2.3

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.2.1
+VERSION := 1.2.3
 else
 VERSION := $(shell git describe --always)
 endif
@@ -54,7 +54,10 @@
 bfs: bftw.o color.o dstring.o eval.o exec.o main.o mtab.o opt.o parse.o printf.o stat.o typo.o util.o
 	$(CC) $(ALL_LDFLAGS) $^ -o $@
 
-release: CFLAGS := -O3 -flto $(WFLAGS) -DNDEBUG -g
+sanitized: CFLAGS := -g $(WFLAGS) -fsanitize=address -fsanitize=undefined
+sanitized: bfs
+
+release: CFLAGS := -g $(WFLAGS) -O3 -flto -DNDEBUG
 release: bfs
 
 %.o: %.c

=== debian/changelog ===
bfs (1.2.3-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 21 Jul 2018 10:22:41 +0800

bfs (1.2.2-2) unstable; urgency=medium

  * Drop dropping the fstype tests; this should have been fixed upstream:
    https://github.com/tavianator/bfs/commit/85caf29cfd2f40ef10ed76d425bb89a5f8f45a1a.
  * Bump Standards-Version to 4.1.5

 -- Chris Lamb <lamby@debian.org>  Fri, 20 Jul 2018 13:16:24 +0800

bfs (1.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 25 Jun 2018 08:33:50 +0100

bfs (1.2.1-2) unstable; urgency=medium

  * Update Vcs-* to point to salsa.debian.org.
  * Bump Standards-Version to 4.1.4.

 -- Chris Lamb <lamby@debian.org>  Thu, 07 Jun 2018 22:51:27 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  debhelper (>= 11),
-Standards-Version: 4.1.3
+Standards-Version: 4.1.5
 Homepage: https://github.com/tavianator/bfs
-Vcs-Git: https://github.com/lamby/pkg-bfs.git
-Vcs-Browser: https://github.com/lamby/pkg-bfs
+Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
+Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs
 
 Package: bfs
 Architecture: any

## bfs 1.3.3

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # bfs                                                                      #
-# Copyright (C) 2015-2017 Tavian Barnes <tavianator@tavianator.com>        #
+# Copyright (C) 2015-2019 Tavian Barnes <tavianator@tavianator.com>        #
 #                                                                          #
 # Permission to use, copy, modify, and/or distribute this software for any #
 # purpose with or without fee is hereby granted.                           #
@@ -15,9 +15,13 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.2.3
+VERSION := 1.3.3
 else
 VERSION := $(shell git describe --always)
+endif
+
+ifndef OS
+OS := $(shell uname)
 endif
 
 CC ?= gcc
@@ -25,7 +29,7 @@
 MKDIR ?= mkdir -p
 RM ?= rm -f
 
-WFLAGS ?= -Wall -Wmissing-declarations
+WFLAGS ?= -Wall -Wmissing-declarations -Wstrict-prototypes
 CFLAGS ?= -g $(WFLAGS)
 LDFLAGS ?=
 DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)
@@ -44,30 +48,66 @@
     -DBFS_VERSION=\"$(VERSION)\"
 
 LOCAL_CFLAGS := -std=c99
+LOCAL_LDFLAGS :=
+LOCAL_LDLIBS :=
+
+ifeq ($(OS),Linux)
+LOCAL_LDFLAGS += -Wl,--as-needed
+LOCAL_LDLIBS += -lacl -lcap -lrt
+
+# These libraries are not build with msan, so disable them
+MSAN_CFLAGS := -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0
+endif
 
 ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
 ALL_CFLAGS = $(ALL_CPPFLAGS) $(LOCAL_CFLAGS) $(CFLAGS) $(DEPFLAGS)
-ALL_LDFLAGS = $(ALL_CFLAGS) $(LDFLAGS)
+ALL_LDFLAGS = $(ALL_CFLAGS) $(LOCAL_LDFLAGS) $(LDFLAGS)
+ALL_LDLIBS = $(LOCAL_LDLIBS) $(LDLIBS)
 
 all: bfs
 
-bfs: bftw.o color.o dstring.o eval.o exec.o main.o mtab.o opt.o parse.o printf.o stat.o typo.o util.o
-	$(CC) $(ALL_LDFLAGS) $^ -o $@
-
-sanitized: CFLAGS := -g $(WFLAGS) -fsanitize=address -fsanitize=undefined
-sanitized: bfs
+bfs: \
+    bftw.o \
+    color.o \
+    diag.o \
+    dstring.o \
+    eval.o \
+    exec.o \
+    main.o \
+    mtab.o \
+    opt.o \
+    parse.o \
+    posix1e.o \
+    printf.o \
+    spawn.o \
+    stat.o \
+    typo.o \
+    util.o
+	$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
 
 release: CFLAGS := -g $(WFLAGS) -O3 -flto -DNDEBUG
 release: bfs
 
+tests/mksock: tests/mksock.o
+	$(CC) $(ALL_LDFLAGS) $^ -o $@
+
 %.o: %.c
 	$(CC) $(ALL_CFLAGS) -c $< -o $@
 
-check: all
+check: all tests/mksock
 	./tests.sh
 
+distcheck:
+	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -fsanitize=undefined -fsanitize=address"
+ifneq ($(OS),Darwin)
+	+$(MAKE) -Bs check CC=clang CFLAGS="$(CFLAGS) $(MSAN_CFLAGS) -fsanitize=memory"
+	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -m32"
+endif
+	+$(MAKE) -Bs release check
+	+$(MAKE) -Bs check
+
 clean:
-	$(RM) bfs *.o *.d
+	$(RM) bfs *.[od] tests/mksock tests/*.[od]
 
 install:
 	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
@@ -77,7 +117,8 @@
 
 uninstall:
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
+	$(RM) $(DESTDIR)$(PREFIX)/share/man/man1/bfs.1
 
-.PHONY: all release check clean install uninstall
+.PHONY: all release check distcheck clean install uninstall
 
 -include $(wildcard *.d)

=== debian/changelog ===
bfs (1.3.3-1) unstable; urgency=medium

  * New upstream release.
  * Use upstream's "check" target over manually calling the "tests.sh" script
    to ensure the "mksock" binary is built for the testsuite.

 -- Chris Lamb <lamby@debian.org>  Wed, 13 Feb 2019 14:35:39 +0100

bfs (1.3.2-2) unstable; urgency=medium

  * Only require libacl1-dev and libcap-dev on Linux. Thanks to Tavian Barnes.
    (Closes: #920288)

 -- Chris Lamb <lamby@debian.org>  Thu, 24 Jan 2019 09:07:43 +0100

bfs (1.3.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 14 Jan 2019 22:57:42 +0000

bfs (1.3.1-1) unstable; urgency=medium

  * New upstream release.
    - Add libacl1-dev & libcap-dev to Build-Depends.
  * Move to debhelper-compat virtual package.
  * Bump debhelper compatibility level to 12.
  * Bump Standards-Version to 4.3.0.

 -- Chris Lamb <lamby@debian.org>  Sat, 05 Jan 2019 22:21:30 +0100

bfs (1.2.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.1.

 -- Chris Lamb <lamby@debian.org>  Mon, 01 Oct 2018 15:17:09 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,10 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 11),
-Standards-Version: 4.1.5
+ debhelper-compat (= 12),
+ libacl1-dev [linux-any],
+ libcap-dev [linux-any],
+Standards-Version: 4.3.0
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.md

## bfs 1.5

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.3.3
+VERSION := 1.5
 else
 VERSION := $(shell git describe --always)
 endif
@@ -53,10 +53,10 @@
 
 ifeq ($(OS),Linux)
 LOCAL_LDFLAGS += -Wl,--as-needed
-LOCAL_LDLIBS += -lacl -lcap -lrt
+LOCAL_LDLIBS += -lacl -lcap -lattr -lrt
 
-# These libraries are not build with msan, so disable them
-MSAN_CFLAGS := -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0
+# These libraries are not built with msan, so disable them
+MSAN_CFLAGS := -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0 -DBFS_HAS_SYS_XATTR=0
 endif
 
 ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
@@ -64,7 +64,9 @@
 ALL_LDFLAGS = $(ALL_CFLAGS) $(LOCAL_LDFLAGS) $(LDFLAGS)
 ALL_LDLIBS = $(LOCAL_LDLIBS) $(LDLIBS)
 
-all: bfs
+default: bfs
+
+all: bfs tests/mksock
 
 bfs: \
     bftw.o \
@@ -73,14 +75,15 @@
     dstring.o \
     eval.o \
     exec.o \
+    fsade.o \
     main.o \
     mtab.o \
     opt.o \
     parse.o \
-    posix1e.o \
     printf.o \
     spawn.o \
     stat.o \
+    trie.o \
     typo.o \
     util.o
 	$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
@@ -94,8 +97,10 @@
 %.o: %.c
 	$(CC) $(ALL_CFLAGS) -c $< -o $@
 
-check: all tests/mksock
-	./tests.sh
+check: all
+	./tests.sh --bfs="$(realpath bfs)"
+	./tests.sh --bfs="$(realpath bfs) -S dfs"
+	./tests.sh --bfs="$(realpath bfs) -S ids"
 
 distcheck:
 	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -fsanitize=undefined -fsanitize=address"
@@ -105,6 +110,9 @@
 endif
 	+$(MAKE) -Bs release check
 	+$(MAKE) -Bs check
+ifeq ($(OS),Linux)
+	./tests.sh --sudo
+endif
 
 clean:
 	$(RM) bfs *.[od] tests/mksock tests/*.[od]

=== debian/changelog ===
bfs (1.5-3) unstable; urgency=medium

  * Sourceful upload to unstable to ensure migration to testing.
  * Bump Standards-Version to 4.4.0.
  * Don't build release tags in gitlab-ci.yml.

 -- Chris Lamb <lamby@debian.org>  Sat, 20 Jul 2019 17:12:34 -0300

bfs (1.5-2) unstable; urgency=medium

  * Add missing "acl" to Build-Depends.

 -- Chris Lamb <lamby@debian.org>  Fri, 05 Jul 2019 14:24:06 -0300

bfs (1.5-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Thu, 04 Jul 2019 10:08:24 -0300

bfs (1.4.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 22 May 2019 10:06:11 +0100

bfs (1.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 22 Apr 2019 17:51:36 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
+ acl,
  debhelper-compat (= 12),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

## bfs 1.5.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # bfs                                                                      #
-# Copyright (C) 2015-2019 Tavian Barnes <tavianator@tavianator.com>        #
+# Copyright (C) 2015-2020 Tavian Barnes <tavianator@tavianator.com>        #
 #                                                                          #
 # Permission to use, copy, modify, and/or distribute this software for any #
 # purpose with or without fee is hereby granted.                           #
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.5
+VERSION := 1.5.2
 else
 VERSION := $(shell git describe --always)
 endif
@@ -36,6 +36,7 @@
 
 DESTDIR ?=
 PREFIX ?= /usr
+MANDIR ?= $(PREFIX)/share/man
 
 LOCAL_CPPFLAGS := \
     -D__EXTENSIONS__ \
@@ -51,12 +52,16 @@
 LOCAL_LDFLAGS :=
 LOCAL_LDLIBS :=
 
+ASAN_CFLAGS := -fsanitize=address
+MSAN_CFLAGS := -fsanitize=memory
+UBSAN_CFLAGS := -fsanitize=undefined
+
 ifeq ($(OS),Linux)
 LOCAL_LDFLAGS += -Wl,--as-needed
 LOCAL_LDLIBS += -lacl -lcap -lattr -lrt
 
 # These libraries are not built with msan, so disable them
-MSAN_CFLAGS := -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0 -DBFS_HAS_SYS_XATTR=0
+MSAN_CFLAGS += -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0 -DBFS_HAS_SYS_XATTR=0
 endif
 
 ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
@@ -71,6 +76,7 @@
 bfs: \
     bftw.o \
     color.o \
+    darray.o \
     diag.o \
     dstring.o \
     eval.o \
@@ -97,21 +103,23 @@
 %.o: %.c
 	$(CC) $(ALL_CFLAGS) -c $< -o $@
 
-check: all
-	./tests.sh --bfs="$(realpath bfs)"
-	./tests.sh --bfs="$(realpath bfs) -S dfs"
-	./tests.sh --bfs="$(realpath bfs) -S ids"
+check: check-bfs check-dfs check-ids
+
+check-%: all
+	./tests.sh --bfs="$(CURDIR)/bfs -S $*"
 
 distcheck:
-	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -fsanitize=undefined -fsanitize=address"
+	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) $(ASAN_CFLAGS) $(UBSAN_CFLAGS)"
 ifneq ($(OS),Darwin)
-	+$(MAKE) -Bs check CC=clang CFLAGS="$(CFLAGS) $(MSAN_CFLAGS) -fsanitize=memory"
+	+$(MAKE) -Bs check CC=clang CFLAGS="$(CFLAGS) $(MSAN_CFLAGS)"
 	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -m32"
 endif
 	+$(MAKE) -Bs release check
 	+$(MAKE) -Bs check
 ifeq ($(OS),Linux)
-	./tests.sh --sudo
+	./tests.sh --sudo --bfs="$(CURDIR)/bfs"
+	./tests.sh --sudo --bfs="$(CURDIR)/bfs -S dfs"
+	./tests.sh --sudo --bfs="$(CURDIR)/bfs -S ids"
 endif
 
 clean:
@@ -120,12 +128,12 @@
 install:
 	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
 	$(INSTALL) -m755 bfs $(DESTDIR)$(PREFIX)/bin/bfs
-	$(MKDIR) $(DESTDIR)$(PREFIX)/share/man/man1
-	$(INSTALL) -m644 bfs.1 $(DESTDIR)$(PREFIX)/share/man/man1/bfs.1
+	$(MKDIR) $(DESTDIR)$(MANDIR)/man1
+	$(INSTALL) -m644 bfs.1 $(DESTDIR)$(MANDIR)/man1/bfs.1
 
 uninstall:
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
-	$(RM) $(DESTDIR)$(PREFIX)/share/man/man1/bfs.1
+	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
 
 .PHONY: all release check distcheck clean install uninstall

=== debian/changelog ===
bfs (1.5.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.4.1.

 -- Chris Lamb <lamby@debian.org>  Tue, 14 Jan 2020 10:58:43 +0000

bfs (1.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Thu, 19 Sep 2019 10:45:32 +0200

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,11 @@
  debhelper-compat (= 12),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs
+Rules-Requires-Root: no
 
 Package: bfs
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -5,5 +5,10 @@
 %:
 	dh $@
 
+override_dh_auto_test:
+ifneq ($(shell id -u),0)
+	dh_auto_test
+endif
+
 override_dh_installchangelogs:
 	dh_installchangelogs RELEASES.md

## bfs 1.7

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.5.2
+VERSION := 1.7
 else
 VERSION := $(shell git describe --always)
 endif
@@ -62,6 +62,24 @@
 
 # These libraries are not built with msan, so disable them
 MSAN_CFLAGS += -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0 -DBFS_HAS_SYS_XATTR=0
+
+DISTCHECK_FLAGS := TEST_FLAGS="--all --sudo"
+endif
+
+ifneq ($(filter asan,$(MAKECMDGOALS)),)
+LOCAL_CFLAGS += $(ASAN_CFLAGS)
+endif
+
+ifneq ($(filter msan,$(MAKECMDGOALS)),)
+LOCAL_CFLAGS += $(MSAN_CFLAGS)
+endif
+
+ifneq ($(filter ubsan,$(MAKECMDGOALS)),)
+LOCAL_CFLAGS += $(UBSAN_CFLAGS)
+endif
+
+ifneq ($(filter release,$(MAKECMDGOALS)),)
+CFLAGS := -g $(WFLAGS) -O3 -flto -DNDEBUG
 endif
 
 ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
@@ -87,15 +105,23 @@
     opt.o \
     parse.o \
     printf.o \
+    pwcache.o \
     spawn.o \
     stat.o \
+    time.o \
     trie.o \
     typo.o \
     util.o
 	$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
 
-release: CFLAGS := -g $(WFLAGS) -O3 -flto -DNDEBUG
+asan: bfs
+	@:
+ubsan: bfs
+	@:
+msan: bfs
+	@:
 release: bfs
+	@:
 
 tests/mksock: tests/mksock.o
 	$(CC) $(ALL_LDFLAGS) $^ -o $@
@@ -106,21 +132,16 @@
 check: check-bfs check-dfs check-ids
 
 check-%: all
-	./tests.sh --bfs="$(CURDIR)/bfs -S $*"
+	./tests.sh --bfs="$(CURDIR)/bfs -S $*" $(TEST_FLAGS)
 
 distcheck:
-	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) $(ASAN_CFLAGS) $(UBSAN_CFLAGS)"
+	+$(MAKE) -B asan ubsan check $(DISTCHECK_FLAGS)
 ifneq ($(OS),Darwin)
-	+$(MAKE) -Bs check CC=clang CFLAGS="$(CFLAGS) $(MSAN_CFLAGS)"
-	+$(MAKE) -Bs check CFLAGS="$(CFLAGS) -m32"
+	+$(MAKE) -B msan check CC=clang $(DISTCHECK_FLAGS)
+	+$(MAKE) -B check CFLAGS="-m32" $(DISTCHECK_FLAGS)
 endif
-	+$(MAKE) -Bs release check
-	+$(MAKE) -Bs check
-ifeq ($(OS),Linux)
-	./tests.sh --sudo --bfs="$(CURDIR)/bfs"
-	./tests.sh --sudo --bfs="$(CURDIR)/bfs -S dfs"
-	./tests.sh --sudo --bfs="$(CURDIR)/bfs -S ids"
-endif
+	+$(MAKE) -B release check $(DISTCHECK_FLAGS)
+	+$(MAKE) -B check $(DISTCHECK_FLAGS)
 
 clean:
 	$(RM) bfs *.[od] tests/mksock tests/*.[od]
@@ -135,6 +156,6 @@
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
 	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
 
-.PHONY: all release check distcheck clean install uninstall
+.PHONY: all asan ubsan msan release check distcheck clean install uninstall
 
 -include $(wildcard *.d)

=== debian/changelog ===
bfs (1.7-1) unstable; urgency=medium

  * New upstream release.
  * Move to debhelper-compat level 13.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 May 2020 16:30:52 +0100

bfs (1.6-4) unstable; urgency=medium

  * Correct reference to DEB_HOST_ARCH_OS to fix FTBFS on kfreebsd-*.

 -- Chris Lamb <lamby@debian.org>  Sun, 08 Mar 2020 13:05:16 -0700

bfs (1.6-3) unstable; urgency=medium

  * Drop extra "D" when disabling extended system attributes on kfreebsd-*.
    Thanks, Tavian.
  * Add missing /usr/share/dpkg/architecture.mk include to ensure population of
    DEB_HOST_ARCH.

 -- Chris Lamb <lamby@debian.org>  Fri, 06 Mar 2020 08:55:44 -0800

bfs (1.6-2) unstable; urgency=medium

  * Fix FTBFS on kFreeBSD.

 -- Chris Lamb <lamby@debian.org>  Wed, 04 Mar 2020 10:05:37 -0800

bfs (1.6-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0.

 -- Chris Lamb <lamby@debian.org>  Sat, 29 Feb 2020 09:28:52 -0800

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  acl,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

## bfs 2.1

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 1.7
+VERSION := 2.1
 else
 VERSION := $(shell git describe --always)
 endif
@@ -29,7 +29,7 @@
 MKDIR ?= mkdir -p
 RM ?= rm -f
 
-WFLAGS ?= -Wall -Wmissing-declarations -Wstrict-prototypes
+WFLAGS ?= -Wall -Wmissing-declarations -Wstrict-prototypes -Wsign-compare
 CFLAGS ?= -g $(WFLAGS)
 LDFLAGS ?=
 DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)
@@ -53,8 +53,9 @@
 LOCAL_LDLIBS :=
 
 ASAN_CFLAGS := -fsanitize=address
-MSAN_CFLAGS := -fsanitize=memory
+MSAN_CFLAGS := -fsanitize=memory -fsanitize-memory-track-origins
 UBSAN_CFLAGS := -fsanitize=undefined
+SANFLAGS := -fno-sanitize-recover
 
 ifeq ($(OS),Linux)
 LOCAL_LDFLAGS += -Wl,--as-needed
@@ -68,14 +69,25 @@
 
 ifneq ($(filter asan,$(MAKECMDGOALS)),)
 LOCAL_CFLAGS += $(ASAN_CFLAGS)
+SANITIZE := y
 endif
 
 ifneq ($(filter msan,$(MAKECMDGOALS)),)
 LOCAL_CFLAGS += $(MSAN_CFLAGS)
+SANITIZE := y
 endif
 
 ifneq ($(filter ubsan,$(MAKECMDGOALS)),)
 LOCAL_CFLAGS += $(UBSAN_CFLAGS)
+SANITIZE := y
+endif
+
+ifdef SANITIZE
+LOCAL_CFLAGS += -fno-sanitize-recover=all
+endif
+
+ifneq ($(filter gcov,$(MAKECMDGOALS)),)
+LOCAL_CFLAGS += --coverage
 endif
 
 ifneq ($(filter release,$(MAKECMDGOALS)),)
@@ -89,11 +101,13 @@
 
 default: bfs
 
-all: bfs tests/mksock
+all: bfs tests/mksock tests/trie tests/xtimegm
 
 bfs: \
+    bar.o \
     bftw.o \
     color.o \
+    ctx.o \
     darray.o \
     diag.o \
     dstring.o \
@@ -120,16 +134,30 @@
 	@:
 msan: bfs
 	@:
+gcov: bfs
+	@:
 release: bfs
 	@:
 
 tests/mksock: tests/mksock.o
 	$(CC) $(ALL_LDFLAGS) $^ -o $@
 
+tests/trie: trie.o tests/trie.o
+	$(CC) $(ALL_LDFLAGS) $^ -o $@
+
+tests/xtimegm: time.o tests/xtimegm.o
+	$(CC) $(ALL_LDFLAGS) $^ -o $@
+
 %.o: %.c
 	$(CC) $(ALL_CFLAGS) -c $< -o $@
 
-check: check-bfs check-dfs check-ids
+check: check-trie check-xtimegm check-bfs check-dfs check-ids check-eds
+
+check-trie: tests/trie
+	$<
+
+check-xtimegm: tests/xtimegm
+	$<
 
 check-%: all
 	./tests.sh --bfs="$(CURDIR)/bfs -S $*" $(TEST_FLAGS)
@@ -144,7 +172,7 @@
 	+$(MAKE) -B check $(DISTCHECK_FLAGS)
 
 clean:
-	$(RM) bfs *.[od] tests/mksock tests/*.[od]
+	$(RM) bfs *.[od] *.gcda *.gcno tests/mksock tests/trie tests/xtimegm tests/*.[od] tests/*.gcda tests/*.gcno
 
 install:
 	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
@@ -156,6 +184,6 @@
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
 	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
 
-.PHONY: all asan ubsan msan release check distcheck clean install uninstall
+.PHONY: all asan ubsan msan release check check-trie check-xtimegm distcheck clean install uninstall
 
 -include $(wildcard *.d)

=== debian/changelog ===
bfs (2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 14 Nov 2020 11:30:05 +0000

bfs (2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 21 Oct 2020 12:28:27 +0100

## bfs 2.2.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # bfs                                                                      #
-# Copyright (C) 2015-2020 Tavian Barnes <tavianator@tavianator.com>        #
+# Copyright (C) 2015-2021 Tavian Barnes <tavianator@tavianator.com>        #
 #                                                                          #
 # Permission to use, copy, modify, and/or distribute this software for any #
 # purpose with or without fee is hereby granted.                           #
@@ -15,13 +15,17 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 2.1
+VERSION := 2.2.1
 else
 VERSION := $(shell git describe --always)
 endif
 
 ifndef OS
 OS := $(shell uname)
+endif
+
+ifndef ARCH
+ARCH := $(shell uname -m)
 endif
 
 CC ?= gcc
@@ -29,8 +33,16 @@
 MKDIR ?= mkdir -p
 RM ?= rm -f
 
-WFLAGS ?= -Wall -Wmissing-declarations -Wstrict-prototypes -Wsign-compare
-CFLAGS ?= -g $(WFLAGS)
+DEFAULT_CFLAGS := \
+    -g \
+    -Wall \
+    -Wmissing-declarations \
+    -Wshadow \
+    -Wsign-compare \
+    -Wstrict-prototypes \
+    -Wimplicit-fallthrough
+
+CFLAGS ?= $(DEFAULT_CFLAGS)
 LDFLAGS ?=
 DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)
 
@@ -55,7 +67,6 @@
 ASAN_CFLAGS := -fsanitize=address
 MSAN_CFLAGS := -fsanitize=memory -fsanitize-memory-track-origins
 UBSAN_CFLAGS := -fsanitize=undefined
-SANFLAGS := -fno-sanitize-recover
 
 ifeq ($(OS),Linux)
 LOCAL_LDFLAGS += -Wl,--as-needed
@@ -64,7 +75,13 @@
 # These libraries are not built with msan, so disable them
 MSAN_CFLAGS += -DBFS_HAS_SYS_ACL=0 -DBFS_HAS_SYS_CAPABILITY=0 -DBFS_HAS_SYS_XATTR=0
 
-DISTCHECK_FLAGS := TEST_FLAGS="--all --sudo"
+DISTCHECK_FLAGS := TEST_FLAGS="--verbose --all --sudo"
+else
+DISTCHECK_FLAGS := TEST_FLAGS="--verbose"
+endif
+
+ifeq ($(OS),NetBSD)
+LOCAL_LDLIBS += -lutil
 endif
 
 ifneq ($(filter asan,$(MAKECMDGOALS)),)
@@ -91,7 +108,7 @@
 endif
 
 ifneq ($(filter release,$(MAKECMDGOALS)),)
-CFLAGS := -g $(WFLAGS) -O3 -flto -DNDEBUG
+CFLAGS := $(DEFAULT_CFLAGS) -O3 -flto -DNDEBUG
 endif
 
 ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS)
@@ -99,9 +116,35 @@
 ALL_LDFLAGS = $(ALL_CFLAGS) $(LOCAL_LDFLAGS) $(LDFLAGS)
 ALL_LDLIBS = $(LOCAL_LDLIBS) $(LDLIBS)
 
+# Save the full set of flags to rebuild everything when they change
+ALL_FLAGS := $(CC) : $(ALL_CFLAGS) : $(ALL_LDFLAGS) : $(ALL_LDLIBS)
+$(shell ./flags.sh $(ALL_FLAGS))
+
+# Goals that make binaries
+BIN_GOALS := bfs tests/mksock tests/trie tests/xtimegm
+
+# Goals that are treated like flags by this Makefile
+FLAG_GOALS := asan msan ubsan gcov release
+
+# These are the remaining non-flag goals
+GOALS := $(filter-out $(FLAG_GOALS),$(MAKECMDGOALS))
+
+# Build the default goal if only flag goals are specified
+FLAG_PREREQS :=
+ifndef GOALS
+FLAG_PREREQS += default
+endif
+
+# The different search strategies that we test
+STRATEGIES := bfs dfs ids eds
+STRATEGY_CHECKS := $(STRATEGIES:%=check-%)
+
+# All the different checks we run
+CHECKS := $(STRATEGY_CHECKS) check-trie check-xtimegm
+
 default: bfs
 
-all: bfs tests/mksock tests/trie tests/xtimegm
+all: $(BIN_GOALS)
 
 bfs: \
     bar.o \
@@ -110,6 +153,7 @@
     ctx.o \
     darray.o \
     diag.o \
+    dir.o \
     dstring.o \
     eval.o \
     exec.o \
@@ -126,64 +170,62 @@
     trie.o \
     typo.o \
     util.o
-	$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
-
-asan: bfs
+
+tests/mksock: tests/mksock.o
+tests/trie: trie.o tests/trie.o
+tests/xtimegm: time.o tests/xtimegm.o
+
+$(BIN_GOALS):
+	+$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
+
+%.o: %.c .flags
+	$(CC) $(ALL_CFLAGS) -c $< -o $@
+
+# Need a rule for .flags to convince make to apply the above pattern rule if
+# .flags didn't exist when make was run
+.flags:
+
+# Make sure that "make release" builds everything, but "make release main.o" doesn't
+$(FLAG_GOALS): $(FLAG_PREREQS)
 	@:
-ubsan: bfs
-	@:
-msan: bfs
-	@:
-gcov: bfs
-	@:
-release: bfs
-	@:
-
-tests/mksock: tests/mksock.o
-	$(CC) $(ALL_LDFLAGS) $^ -o $@
-
-tests/trie: trie.o tests/trie.o
-	$(CC) $(ALL_LDFLAGS) $^ -o $@
-
-tests/xtimegm: time.o tests/xtimegm.o
-	$(CC) $(ALL_LDFLAGS) $^ -o $@
-
-%.o: %.c
-	$(CC) $(ALL_CFLAGS) -c $< -o $@
-
-check: check-trie check-xtimegm check-bfs check-dfs check-ids check-eds
-
-check-trie: tests/trie
+
+check: $(CHECKS)
+
+$(STRATEGY_CHECKS): check-%: bfs tests/mksock
+	./tests.sh --bfs="$(CURDIR)/bfs -S $*" $(TEST_FLAGS)
+
+check-trie check-xtimegm: check-%: tests/%
 	$<
-
-check-xtimegm: tests/xtimegm
-	$<
-
-check-%: all
-	./tests.sh --bfs="$(CURDIR)/bfs -S $*" $(TEST_FLAGS)
 
 distcheck:
 	+$(MAKE) -B asan ubsan check $(DISTCHECK_FLAGS)
 ifneq ($(OS),Darwin)
 	+$(MAKE) -B msan check CC=clang $(DISTCHECK_FLAGS)
+ifeq ($(ARCH),x86_64)
 	+$(MAKE) -B check CFLAGS="-m32" $(DISTCHECK_FLAGS)
+endif
 endif
 	+$(MAKE) -B release check $(DISTCHECK_FLAGS)
 	+$(MAKE) -B check $(DISTCHECK_FLAGS)
 
 clean:
-	$(RM) bfs *.[od] *.gcda *.gcno tests/mksock tests/trie tests/xtimegm tests/*.[od] tests/*.gcda tests/*.gcno
+	$(RM) $(BIN_GOALS) .flags *.[od] *.gcda *.gcno tests/*.[od] tests/*.gcda tests/*.gcno
 
 install:
 	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
 	$(INSTALL) -m755 bfs $(DESTDIR)$(PREFIX)/bin/bfs
 	$(MKDIR) $(DESTDIR)$(MANDIR)/man1
 	$(INSTALL) -m644 bfs.1 $(DESTDIR)$(MANDIR)/man1/bfs.1
+	$(MKDIR) $(DESTDIR)$(PREFIX)/share/bash-completion/completions
+	$(INSTALL) -m644 completions/bfs.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
 
 uninstall:
+	$(RM) $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
+	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
 	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
-	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
-
-.PHONY: all asan ubsan msan release check check-trie check-xtimegm distcheck clean install uninstall
+
+.PHONY: default all $(FLAG_GOALS) check $(CHECKS) distcheck clean install uninstall
+
+.SUFFIXES:
 
 -include $(wildcard *.d)

=== debian/changelog ===
bfs (2.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 09 Jun 2021 08:03:39 +0100

bfs (2.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.1.

 -- Chris Lamb <lamby@debian.org>  Wed, 10 Mar 2021 08:41:04 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,12 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/architecture.mk
+
+# Fix FTBFS on kfreebsd-* architectures
+# https://github.com/tavianator/bfs/issues/56
+ifneq (,$(filter kfreebsd,$(DEB_HOST_ARCH_OS)))
+export DEB_CFLAGS_MAINT_APPEND = -DBFS_HAS_SYS_EXTATTR=0
+endif
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all

## bfs 2.3.1

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################################
 
 ifeq ($(wildcard .git),)
-VERSION := 2.2.1
+VERSION := 2.3.1
 else
 VERSION := $(shell git describe --always)
 endif

=== debian/changelog ===
bfs (2.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 22 Jan 2022 08:00:22 -0800

bfs (2.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0.

 -- Chris Lamb <lamby@debian.org>  Wed, 01 Dec 2021 08:50:04 -0800

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

## bfs 2.6.1

=== Makefile ===
############################################################################
# bfs                                                                      #
# Copyright (C) 2015-2021 Tavian Barnes <tavianator@tavianator.com>        #
#                                                                          #
# Permission to use, copy, modify, and/or distribute this software for any #
# purpose with or without fee is hereby granted.                           #
#                                                                          #
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES #
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF         #
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR  #
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   #
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN    #
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF  #
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.           #
############################################################################

ifneq ($(wildcard .git),)
VERSION := $(shell git describe --always 2>/dev/null)
endif

ifndef VERSION
VERSION := 2.6.1
endif

ifndef OS
OS := $(shell uname)
endif

ifndef ARCH
ARCH := $(shell uname -m)
endif

CC ?= gcc
INSTALL ?= install
MKDIR ?= mkdir -p
RM ?= rm -f

export BUILDDIR ?= .
DESTDIR ?=
PREFIX ?= /usr
MANDIR ?= $(PREFIX)/share/man

BIN := $(BUILDDIR)/bin
OBJ := $(BUILDDIR)/obj

DEFAULT_CFLAGS := \
    -g \
    -Wall \
    -Wmissing-declarations \
    -Wshadow \
    -Wsign-compare \
    -Wstrict-prototypes \
    -Wimplicit-fallthrough

CFLAGS ?= $(DEFAULT_CFLAGS)
LDFLAGS ?=
DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)

LOCAL_CPPFLAGS := \
    -D__EXTENSIONS__ \
    -D_ATFILE_SOURCE \
    -D_BSD_SOURCE \
    -D_DARWIN_C_SOURCE \
    -D_DEFAULT_SOURCE \
    -D_FILE_OFFSET_BITS=64 \
    -D_TIME_BITS=64 \
    -D_GNU_SOURCE \
    -DBFS_VERSION=\"$(VERSION)\"

LOCAL_CFLAGS := -std=c11
LOCAL_LDFLAGS :=
LOCAL_LDLIBS :=

ASAN := $(filter asan,$(MAKECMDGOALS))
LSAN := $(filter lsan,$(MAKECMDGOALS))
MSAN := $(filter msan,$(MAKECMDGOALS))
TSAN := $(filter tsan,$(MAKECMDGOALS))
UBSAN := $(filter ubsan,$(MAKECMDGOALS))

ifndef MSAN
WITH_ONIGURUMA := y
endif

ifdef WITH_ONIGURUMA
LOCAL_CPPFLAGS += -DBFS_WITH_ONIGURUMA=1

ONIG_CONFIG := $(shell command -v onig-config 2>/dev/null)
ifdef ONIG_CONFIG
ONIG_CFLAGS := $(shell $(ONIG_CONFIG) --cflags)
ONIG_LDLIBS := $(shell $(ONIG_CONFIG) --libs)
else
ONIG_LDLIBS := -lonig
endif

LOCAL_CFLAGS += $(ONIG_CFLAGS)
LOCAL_LDLIBS += $(ONIG_LDLIBS)
endif

ifeq ($(OS),Linux)
ifndef MSAN # These libraries are not built with msan
WITH_ACL := y
WITH_ATTR := y
WITH_LIBCAP := y
endif

ifdef WITH_ACL
LOCAL_LDLIBS += -lacl
else
LOCAL_CPPFLAGS += -DBFS_HAS_SYS_ACL=0
endif

ifdef WITH_ATTR
LOCAL_LDLIBS += -lattr
else
LOCAL_CPPFLAGS += -DBFS_HAS_SYS_XATTR=0
endif

ifdef WITH_LIBCAP
LOCAL_LDLIBS += -lcap
else
LOCAL_CPPFLAGS += -DBFS_HAS_SYS_CAPABILITY=0
endif

LOCAL_LDFLAGS += -Wl,--as-needed
LOCAL_LDLIBS += -lrt
endif

ifeq ($(OS),NetBSD)
LOCAL_LDLIBS += -lutil
endif

ifdef ASAN
LOCAL_CFLAGS += -fsanitize=address
SANITIZE := y
endif

ifdef LSAN
LOCAL_CFLAGS += -fsanitize=leak
SANITIZE := y
endif

ifdef MSAN
LOCAL_CFLAGS += -fsanitize=memory -fsanitize-memory-track-origins
SANITIZE := y
endif

ifdef TSAN
LOCAL_CFLAGS += -fsanitize=thread
SANITIZE := y
endif

ifdef UBSAN
LOCAL_CFLAGS += -fsanitize=undefined
SANITIZE := y
endif

ifdef SANITIZE
LOCAL_CFLAGS += -fno-sanitize-recover=all
endif

ifneq ($(filter gcov,$(MAKECMDGOALS)),)
LOCAL_CFLAGS += --coverage
# gcov only intercepts fork()/exec() with -std=gnu*
LOCAL_CFLAGS := $(patsubst -std=c%,-std=gnu%,$(LOCAL_CFLAGS))
endif

ifneq ($(filter release,$(MAKECMDGOALS)),)
CFLAGS := $(DEFAULT_CFLAGS) -O3 -flto -DNDEBUG
endif

ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS) $(EXTRA_CPPFLAGS)
ALL_CFLAGS = $(ALL_CPPFLAGS) $(LOCAL_CFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $(DEPFLAGS)
ALL_LDFLAGS = $(ALL_CFLAGS) $(LOCAL_LDFLAGS) $(LDFLAGS) $(EXTRA_LDFLAGS)
ALL_LDLIBS = $(LOCAL_LDLIBS) $(LDLIBS) $(EXTRA_LDLIBS)

# Goals that are treated like flags by this Makefile
FLAG_GOALS := asan lsan msan tsan ubsan gcov release

# These are the remaining non-flag goals
GOALS := $(filter-out $(FLAG_GOALS),$(MAKECMDGOALS))

# Build the default goal if only flag goals are specified
FLAG_PREREQS :=
ifndef GOALS
FLAG_PREREQS += bfs
endif

# The different search strategies that we test
STRATEGIES := bfs dfs ids eds
STRATEGY_CHECKS := $(STRATEGIES:%=check-%)

# All the different checks we run
CHECKS := $(STRATEGY_CHECKS) check-trie check-xtimegm

# Custom test flags for distcheck
DISTCHECK_FLAGS := -s TEST_FLAGS="--sudo --verbose=skipped"

bfs: $(BIN)/bfs
.PHONY: bfs

all: $(BIN)/bfs $(BIN)/tests/mksock $(BIN)/tests/trie $(BIN)/tests/xtimegm
.PHONY: all

$(BIN)/bfs: \
    $(OBJ)/src/bar.o \
    $(OBJ)/src/bftw.o \
    $(OBJ)/src/color.o \
    $(OBJ)/src/ctx.o \
    $(OBJ)/src/darray.o \
    $(OBJ)/src/diag.o \
    $(OBJ)/src/dir.o \
    $(OBJ)/src/dstring.o \
    $(OBJ)/src/eval.o \
    $(OBJ)/src/exec.o \
    $(OBJ)/src/fsade.o \
    $(OBJ)/src/main.o \
    $(OBJ)/src/mtab.o \
    $(OBJ)/src/opt.o \
    $(OBJ)/src/parse.o \
    $(OBJ)/src/printf.o \
    $(OBJ)/src/pwcache.o \
    $(OBJ)/src/stat.o \
    $(OBJ)/src/trie.o \
    $(OBJ)/src/typo.o \
    $(OBJ)/src/util.o \
    $(OBJ)/src/xregex.o \
    $(OBJ)/src/xspawn.o \
    $(OBJ)/src/xtime.o

$(BIN)/tests/mksock: $(OBJ)/tests/mksock.o
$(BIN)/tests/trie: $(OBJ)/src/trie.o $(OBJ)/tests/trie.o
$(BIN)/tests/xtimegm: $(OBJ)/src/xtime.o $(OBJ)/tests/xtimegm.o

$(BIN)/%:
	@$(MKDIR) $(@D)
	+$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@

$(OBJ)/%.o: %.c $(OBJ)/FLAGS
	@$(MKDIR) $(@D)
	$(CC) $(ALL_CFLAGS) -c $< -o $@

# Save the full set of flags to rebuild everything when they change
$(OBJ)/FLAGS.new:
	@$(MKDIR) $(@D)
	@echo $(CC) : $(ALL_CFLAGS) : $(ALL_LDFLAGS) : $(ALL_LDLIBS) >$@
.PHONY: $(OBJ)/FLAGS.new

# Only update obj/FLAGS if obj/FLAGS.new is different
$(OBJ)/FLAGS: $(OBJ)/FLAGS.new
	@test -e $@ && cmp -s $@ $< && rm $< || mv $< $@

# Make sure that "make release" builds everything, but "make release obj/src/main.o" doesn't
$(FLAG_GOALS): $(FLAG_PREREQS)
	@:
.PHONY: $(FLAG_GOALS)

check: $(CHECKS)
.PHONY: check $(CHECKS)

$(STRATEGY_CHECKS): check-%: $(BIN)/bfs $(BIN)/tests/mksock
	./tests/tests.sh --bfs="$(BIN)/bfs -S $*" $(TEST_FLAGS)

check-trie check-xtimegm: check-%: $(BIN)/tests/%
	$<

distcheck:
	+$(MAKE) -B asan ubsan check $(DISTCHECK_FLAGS)
ifneq ($(OS),Darwin)
	+$(MAKE) -B msan check CC=clang $(DISTCHECK_FLAGS)
endif
ifeq ($(OS) $(ARCH),Linux x86_64)
	+$(MAKE) -B check EXTRA_CFLAGS="-m32" ONIG_CONFIG= $(DISTCHECK_FLAGS)
endif
	+$(MAKE) -B release check $(DISTCHECK_FLAGS)
	+$(MAKE) -B check $(DISTCHECK_FLAGS)
	+$(MAKE) check-install $(DISTCHECK_FLAGS)
.PHONY: distcheck

clean:
	$(RM) -r $(BIN) $(OBJ)
.PHONY: clean

install:
	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m755 $(BIN)/bfs $(DESTDIR)$(PREFIX)/bin/bfs
	$(MKDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m644 docs/bfs.1 $(DESTDIR)$(MANDIR)/man1/bfs.1
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	$(INSTALL) -m644 completions/bfs.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/zsh/site-functions
	$(INSTALL) -m644 completions/bfs.zsh $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_bfs
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d
	$(INSTALL) -m644 completions/bfs.fish $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/bfs.fish
.PHONY: install

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
	$(RM) $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_bfs
	$(RM) $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/bfs.fish
	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
.PHONY: uninstall

check-install:
	+$(MAKE) install DESTDIR=$(BUILDDIR)/pkg
	+$(MAKE) uninstall DESTDIR=$(BUILDDIR)/pkg
	$(BIN)/bfs $(BUILDDIR)/pkg -not -type d -print -exit 1
	$(RM) -r $(BUILDDIR)/pkg
.PHONY: check-install

.SUFFIXES:

-include $(wildcard $(OBJ)/*/*.d)

=== debian/changelog ===
bfs (2.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.1.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Jul 2022 08:23:39 +0100

bfs (2.6-1) unstable; urgency=medium

  * New upstream release.
  - Update name of RELEASES.md.
  - Update location of bfs.1 manpage.
  * Install more documentation shipped by upstream.

 -- Chris Lamb <lamby@debian.org>  Sat, 28 May 2022 06:53:43 +0100

bfs (2.5-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sun, 03 Apr 2022 09:42:46 +0100

bfs (2.4.1-1) unstable; urgency=medium

  * New upstream release.
    - Add libonig-dev to Build-Depends.
  * Update debian/copyright.
  * Update debian/watch format.

 -- Chris Lamb <lamby@debian.org>  Sat, 26 Feb 2022 07:11:24 +0000

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
  debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
-Standards-Version: 4.6.0
+ libonig-dev,
+Standards-Version: 4.6.1
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

=== debian/watch ===
version=4
https://github.com/tavianator/bfs/releases .*/(.*)\.tar\.gz
